﻿using System;

namespace Урок_7._1
{
    class Program
    {
        static void Main(string[] args)
        {
            /*
             *    ООП. Модификатор static. Статические члены класса. Статические классы
             */

            #region Статические члены

            // Создадим три объекта одного и того же класса, можно использовать классы у которых есть общий родитель
            // если в родителе объявлены статические члены.
            // Внутри Trade класса есть статические счетчики. Один объявлен через статическое поле, другой через свойство.
            // Рассмотрим как это работает, и как к ним обращаться.
            var trade0 = new Trade(13);
            var trade1 = new Trade(166);
            var trade2 = new Trade(222);

            var trdNo = trade0.TradeNo;
            trdNo = trade1.TradeNo;
            trdNo = trade2.TradeNo;

            // Поскольку внутри класса только поле объявлено static, то для получения данных мы обязательно должны использовать
            // обращение к нему через свойство объекта. Хотя и поле существует всегда даже без объектов, просто нет доступа к нему.
            Console.WriteLine("Счетчик обращений равен {0}, после поочередного считывания свойств трех объектов Trade.", trade0.GetCounter);

            trade0.TradeNo = 456;
            trade1.TradeNo = 123;
            trade2.TradeNo = 321;

            // Свойство SetCounter объявлено как static, поэтому к нему можно обращаться без использования объектов воообще
            // оно доступно через имя класса. Через объект обращаться к нему не получится.
            Console.WriteLine("Счетчик записей равен {0}, после поочередной записи свойств трех объектов Trade.", Trade.SetCounter);

            Console.ReadKey();

            #endregion

            #region Статические классы

            // При работе со стат классами важно помнить что нельзя создавать экземпляры, нельзя наследовать, можно
            // обращаться к членам только через имя класса.
            // var sttc = new StaticClass();    // ОШИБКА!! Нельзя создать экземпляр статического класса

            // При первом обращении к свойству класса будет вызван его конструктор автоматом.
            Console.WriteLine("Свойство статического класса равно {0}", StaticClass.IsStatic);

            Console.ReadKey();

            #endregion
        }
    }
}
