﻿namespace Урок_7._1
{
    class Trade
    {
        private long _tradeNo;
        /// <summary>
        /// Делаем данное поле статичским. Тогда всегда будет существовать только
        /// один экземпляр данного поля, для всех объектов этого класса.
        /// </summary>
        private static ulong _getCounter;      // Поле для учета чтений данных


        public long TradeNo
        {
            get
            {
                _getCounter++;
                return _tradeNo;
            }
            set
            {
                if (_tradeNo == value)
                    return;

                SetCounter++;
                _tradeNo = value;
            }
        }

        public ulong GetCounter
        {
            get { return _getCounter; }
            
        }
        /// <summary>
        /// Число изменений данных. Данное свойство разрешает запись только ВНУТРИ класса.
        /// Такой ход позволяет использовать автосвойства даже если нужна закрытая инициализация.
        /// Свойство делаем статическим, к нему можно обращаться даже тогда когда нет объектов еще никаких.
        /// Для всех объектов счетчик будет ОДИН общий.
        /// Суть в том что будет создано некое статическое поле, которое нам недоступно и информация будет храниться в поле.
        /// </summary>
        public static ulong SetCounter { get; private set; }
        

        public Trade()
        {
            // В конструкторе по умолчанию мы инициализируем все значения класса дефолт величинами.
            _tradeNo = new long();

            _getCounter = 0;
            SetCounter = 0;
        }

        public Trade(long tradeNo) : this()         // Через такой прием мы сначала вызываем конструктор по умолчанию,
                                                    // он инициализирует поля, потом нужные нам мы используем для забивки значений.
        {
            _tradeNo = tradeNo;
        }
    }
}
