﻿using TSLab.Script;
using TSLab.Script.Handlers;

namespace Урок_7._3
{
    /// <summary>
    /// Скрипт входит в позицию по рынку. Далее выставляет стоп и тейк для позиции.
    /// Данная версия уже подходит для лаборатории ибо учитывает историю свечек.
    /// </summary>
    public class EntryWithStopTake : IExternalScript
    {
        public void Execute(IContext ctx, ISecurity sec)
        {
            // Внутрь нам подается список свечей. Все так же как в кубиках.
            // Мы должны отработать все свечки и сгенерить сигналы. Сигнал 
            // уходящий в будущее будет исполнен на рынке.
            for (int i = 0; i < ctx.BarsCount; i++)
            {
                // Лонг
                var le = sec.Positions.GetLastActiveForSignal("LE");
                if (le == null)
                    sec.Positions.BuyAtMarket(i+1, 1, "LE");
                else
                {
                    le.CloseAtStop(i+1, le.EntryPrice*0.995, "LXS");
                    le.CloseAtProfit(i+1, le.EntryPrice*1.005, "LXP");
                }



                // Шорт
                var se = sec.Positions.GetLastActiveForSignal("SE");
                if (se == null)
                    sec.Positions.SellAtMarket(i+1, 1, "SE");
                else
                {
                    se.CloseAtStop(i+1, se.EntryPrice*1.005, "SXS");
                    se.CloseAtProfit(i+1, se.EntryPrice*0.995, "SXP");
                }
            }
        }
    }
}
