﻿using TSLab.Script;
using TSLab.Script.Handlers;

namespace Урок_7._3
{
    /// <summary>
    /// Скрипт входит в позицию по рынку. Далее выставляет стоп и тейк для позиции.
    /// </summary>
    public class EntryWithStopTakeTest : IExternalScript
    {
        public void Execute(IContext ctx, ISecurity sec)
        {
            // Лонг
            // Входим по рынку, после входа в позицию ставим стоп и тейк.
            // Нужно иметь ввиду что стоп с тейком будут выставлены не  сразу после подачи сигнала на вход
            // а только после очередного пересчета, когда сигнал на вход будет выполнен. Для обычного случая
            // когда пересчет идет интервалом, это будет следующий бар после входа.
            var le = sec.Positions.GetLastActiveForSignal("LE");
            if (le == null)
                sec.Positions.BuyAtMarket(ctx.BarsCount, 1, "LE");
            else
            {
                // Стоп и тейк ставятся условными заявками. В зависимости от брокера
                // это может быть 2 связанные заявки, а может быть одна наиболее близкая заявка к цене. Либо стоп либо тейк.
                // Для Transaq связанная заявка выглядит как одна заявка. В комментарии к заявке видно что она связанная.
                // Цену стопа и тейка ставим на 0,5% от цены входа.
                le.CloseAtStop(ctx.BarsCount, le.EntryPrice * 0.995, "LXS");
                le.CloseAtProfit(ctx.BarsCount, le.EntryPrice * 1.005, "LXP");
            }



            // Шорт
            var se = sec.Positions.GetLastActiveForSignal("SE");
            if (se == null)
                sec.Positions.SellAtMarket(ctx.BarsCount, 1, "SE");
            else
            {

                se.CloseAtStop(ctx.BarsCount, se.EntryPrice * 1.005, "SXS");
                se.CloseAtProfit(ctx.BarsCount, se.EntryPrice * 0.995, "SXP");
            }
        }
    }
}
