﻿using System.Linq;
using TSLab.Script;
using TSLab.Script.Handlers;

namespace Урок_7._3
{
    /// <summary>
    /// Скрипт выставляет заявку по инструменту лимитную на некотором отдалении от рынка, чтобы она не исполнялась.
    /// Далее с каждым пересчетом заявка будет переставляться если цена ушла ближе/дальше
    /// </summary>
    public class LimitOrderTest : IExternalScript
    {
        public void Execute(IContext ctx, ISecurity sec)
        {
            // Получаем текущую цену. Текущая цена это по факту цена закрытия последнего бара.
            var currentPrice = sec.Bars.Last().Close;

            // При выставлении лимитных заявок нужно отталкиваться от брокера.
            // Некоторые брокеры лимитную заявку выше рынка для лонга считают рыночной и исполняют по рынку.
            // transaq сервер как раз и делает так. Будем ставить заявки ниже рынка для лонга, выше для шорта
            // Обязательно для разных входов, задаем разные сигналы
            sec.Positions.BuyAtPrice(ctx.BarsCount, 1, currentPrice * 0.995, "LE");
            sec.Positions.SellAtPrice(ctx.BarsCount, 1, currentPrice * 1.005, "SE");
        }
    }
}
