﻿using TSLab.Script;
using TSLab.Script.Handlers;

namespace Урок_7._3
{
    public class SampleScript : IExternalScript
    {
        public void Execute(IContext ctx, ISecurity sec)
        {
            /*
             *      Использование методов расширения для упрощения кода.
             */
            
            // выводим сообщение в лог
            ctx.LogInfo("Скрипт отработал.");

            // Попробуем сделать тоже самое что делали на прошлом уроке, в чуть упрощенной форме.
            // Для расчета тела свечи используем метод расширения.
            var color = System.Drawing.Color.Red;       // Используем набор системных цветов, чтобы не собирать цифрами

            // Выводим цены закрытия на вторую панель
            var pane = ctx.CreatePane("Вторая панель", 25, false);      // Создаем новую граф. панель. 
            pane.AddList("Цена закрытия", sec.ClosePrices, ListStyles.LINE, new Color(color.ToArgb()), LineStyles.SOLID, PaneSides.LEFT);

            // Выводим длину тела свечи на вторую панель
            // Для расчета длины тела надо создать новый список и туда поместить разницу. Далее его вывести
            // Используем созданный метод расширения класса IList для этих целей. Получим компактную запись.
            var bodyLen = sec.OpenPrices.Subtract(sec.ClosePrices);     
            color = System.Drawing.Color.Blue;
            pane.AddList("Длина тела", bodyLen, ListStyles.LINE, new Color(color.ToArgb()), LineStyles.SOLID, PaneSides.RIGHT);

        }
    }
}
