﻿using System.Linq;
using TSLab.Script;
using TSLab.Script.Handlers;

namespace Урок_7._3
{
    /// <summary>
    /// Скрипт выставляет заявку по инструменту условную на некотором отдалении от рынка, чтобы она не исполнялась.
    /// Далее с каждым пересчетом заявка будет переставляться если цена ушла ближе/дальше
    /// </summary>
    public class StopOrderTest : IExternalScript
    {
        public void Execute(IContext ctx, ISecurity sec)
        {
            // Получаем текущую цену. Текущая цена это по факту цена закрытия последнего бара.
            var currentPrice = sec.Bars.Last().Close;

            // Обязательно для разных входов, задаем разные сигналы
            sec.Positions.BuyIfGreater(ctx.BarsCount, 1, currentPrice * 1.005, "LE");
            sec.Positions.SellIfLess(ctx.BarsCount, 1, currentPrice * 0.995, "SE");
        }
    }
}
